> ## Documentation Index
> Fetch the complete documentation index at: https://docs.eigenexplorer.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Retrieve all withdrawal events

> Returns a list of all withdrawal events.

<Note>
  The default date range between `startAt` and `endAt` is 7 days, with `startAt` set 7 days before `endAt`.

  By default, `endAt` is set to the current timestamp (now).\
  The maximum allowed date range is 30 days.
</Note>


## OpenAPI

````yaml get /events/withdrawal
openapi: 3.0.3
info:
  title: EigenExplorer API
  description: EigenExplorer is a community-driven data platform for EigenLayer AVS.
  version: 0.0.1
  license:
    name: MIT
    url: https://spdx.org/licenses/MIT.html
servers:
  - url: https://api.eigenexplorer.com
    description: EigenExplorer Production API
  - url: https://api-holesky.eigenexplorer.com
    description: EigenExplorer Holesky Testnet API
security: []
paths:
  /events/withdrawal:
    get:
      tags:
        - Events
      summary: Retrieve all withdrawal events
      description: Returns a list of all withdrawal events.
      operationId: getWithdrawalEvents
      parameters:
        - in: query
          name: txHash
          description: The transaction hash associated with the event
          schema:
            type: string
            pattern: ^0x([A-Fa-f0-9]{64})$
            description: The transaction hash associated with the event
        - in: query
          name: startAt
          description: Start date in ISO string format
          schema:
            type: string
            description: Start date in ISO string format
            example: '2024-11-15T00:00:00.000Z'
        - in: query
          name: endAt
          description: End date in ISO string format
          schema:
            type: string
            description: End date in ISO string format
            example: '2024-12-15T00:00:00.000Z'
        - in: query
          name: type
          description: The type of the withdrawal event
          schema:
            type: string
            enum:
              - WITHDRAWAL_QUEUED
              - WITHDRAWAL_COMPLETED
            description: The type of the withdrawal event
        - in: query
          name: withdrawalRoot
          description: The withdrawal root associated with the event
          schema:
            type: string
            pattern: ^0x[a-fA-F0-9]{64}$
            description: The withdrawal root associated with the event
        - in: query
          name: delegatedTo
          description: The address to which funds were delegated
          schema:
            type: string
            pattern: ^0x[a-fA-F0-9]{40}$
            description: The address to which funds were delegated
        - in: query
          name: withdrawer
          description: The address of the withdrawer
          schema:
            type: string
            pattern: ^0x[a-fA-F0-9]{40}$
            description: The address of the withdrawer
        - in: query
          name: withTokenData
          description: >-
            Toggle whether the route should return underlying token address and
            underlying value
          schema:
            type: string
            enum:
              - 'true'
              - 'false'
            default: 'false'
            description: >-
              Toggle whether the route should return underlying token address
              and underlying value
            example: 'false'
        - in: query
          name: withEthValue
          description: Toggle whether the route should return value denominated in ETH
          schema:
            type: string
            enum:
              - 'true'
              - 'false'
            default: 'false'
            description: Toggle whether the route should return value denominated in ETH
            example: 'false'
        - in: query
          name: skip
          description: The number of records to skip for pagination
          schema:
            type: string
            default: '0'
            description: The number of records to skip for pagination
            example: 0
        - in: query
          name: take
          description: The number of records to return for pagination
          schema:
            type: string
            default: '12'
            description: The number of records to return for pagination
            example: 12
        - in: header
          name: X-API-Token
          description: API Token for authentication
          schema:
            type: string
            description: API Token for authentication
          required: true
      responses:
        '200':
          description: The withdrawal events found.
          content:
            application/json:
              schema:
                type: object
                properties:
                  tx:
                    type: string
                    description: The transaction hash
                    example: >-
                      0xae41958d0342a4485536f701c72723625131680f182eb21f95abdac6d74d0ff0
                  blockNumber:
                    type: number
                    description: The block number of the transaction
                    example: 21045085
                  blockTime:
                    type: string
                    description: The block time of the transaction as an ISO 8601 string
                    example: '2024-10-25T20:41:11.000Z'
                  type:
                    type: string
                    enum:
                      - WITHDRAWAL_QUEUED
                      - WITHDRAWAL_COMPLETED
                    description: The type of the event
                    example: WITHDRAWAL_QUEUED
                  args:
                    type: object
                    properties:
                      staker:
                        type: string
                        description: >-
                          The contract address of the staker who initiated the
                          withdrawal
                        example: '0x513ea5a99988252f3b2cd8382ac077d7fd26ef48'
                      withdrawalRoot:
                        type: string
                        description: The root hash of the withdrawal
                        example: >-
                          0xe6cdf9110330e1648039cb98e680aeb9d1c63e022764186f1131eb9432605421
                      delegatedTo:
                        type: string
                        description: >-
                          The address to which the staker was delegated when the
                          withdrawal was initiated
                        example: '0x4cd2086e1d708e65db5d4f5712a9ca46ed4bbd0a'
                      withdrawer:
                        type: string
                        description: >-
                          The address of the withdrawer, authorized to complete
                          the withdrawal and receive the funds
                        example: '0x513ea5a99988252f3b2cd8382ac077d7fd26ef48'
                      nonce:
                        type: number
                        description: >-
                          The nonce of the withdrawal, ensuring unique hashes
                          for otherwise identical withdrawals
                        example: 0
                      startBlock:
                        type: number
                        description: The block number when the withdrawal was created
                        example: 21054925
                      strategies:
                        type: array
                        items:
                          type: object
                          properties:
                            strategy:
                              type: string
                              description: The contract address of the restaking strategy
                              example: '0xacb55c530acdb2849e6d4f36992cd8c9d50ed8f7'
                            shares:
                              type: string
                              description: The amount of shares withdrawn for each strategy
                              example: '1000000000000000000'
                            underlyingToken:
                              type: string
                              description: >-
                                The contract address of the token associated
                                with this strategy
                              example: '0xae7ab96520DE3A18E5e111B5EaAb095312D7fE84'
                            underlyingValue:
                              type: number
                              description: >-
                                The value of the shares in terms of the
                                underlying token
                              example: 5
                            ethValue:
                              type: number
                              description: The value of the shares in ETH
                              example: 1
                          required:
                            - strategy
                            - shares
                    required:
                      - withdrawalRoot
                required:
                  - tx
                  - blockNumber
                  - blockTime
                  - type
                  - args
        '400':
          $ref: '#/components/responses/400'
        '401':
          $ref: '#/components/responses/401'
        '403':
          $ref: '#/components/responses/403'
        '404':
          $ref: '#/components/responses/404'
        '422':
          $ref: '#/components/responses/422'
        '429':
          $ref: '#/components/responses/429'
        '500':
          $ref: '#/components/responses/500'
components:
  responses:
    '400':
      description: >-
        The server cannot or will not process the request due to something that
        is perceived to be a client error (e.g., malformed request syntax,
        invalid request message framing, or deceptive request routing).
      content:
        application/json:
          schema:
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - bad_request
                    description: A short code indicating the error code returned.
                    example: bad_request
                  message:
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: >-
                      https://docs.eigenexplorer.com/api-reference/errors#bad_request
                required:
                  - code
                  - message
            required:
              - error
    '401':
      description: >-
        Although the HTTP standard specifies "unauthorized", semantically this
        response means "unauthenticated". That is, the client must authenticate
        itself to get the requested response.
      content:
        application/json:
          schema:
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - unauthorized
                    description: A short code indicating the error code returned.
                    example: unauthorized
                  message:
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: >-
                      https://docs.eigenexplorer.com/api-reference/errors#unauthorized
                required:
                  - code
                  - message
            required:
              - error
    '403':
      description: >-
        The client does not have access rights to the content; that is, it is
        unauthorized, so the server is refusing to give the requested resource.
        Unlike 401 Unauthorized, the client's identity is known to the server.
      content:
        application/json:
          schema:
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - forbidden
                    description: A short code indicating the error code returned.
                    example: forbidden
                  message:
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: >-
                      https://docs.eigenexplorer.com/api-reference/errors#forbidden
                required:
                  - code
                  - message
            required:
              - error
    '404':
      description: The server cannot find the requested resource.
      content:
        application/json:
          schema:
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - not_found
                    description: A short code indicating the error code returned.
                    example: not_found
                  message:
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: >-
                      https://docs.eigenexplorer.com/api-reference/errors#not_found
                required:
                  - code
                  - message
            required:
              - error
    '422':
      description: >-
        The request was well-formed but was unable to be followed due to
        semantic errors.
      content:
        application/json:
          schema:
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - unprocessable_entity
                    description: A short code indicating the error code returned.
                    example: unprocessable_entity
                  message:
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: >-
                      https://docs.eigenexplorer.com/api-reference/errors#unprocessable_entity
                required:
                  - code
                  - message
            required:
              - error
    '429':
      description: >-
        The user has sent too many requests in a given amount of time ("rate
        limiting")
      content:
        application/json:
          schema:
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - rate_limit_exceeded
                    description: A short code indicating the error code returned.
                    example: rate_limit_exceeded
                  message:
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: >-
                      https://docs.eigenexplorer.com/api-reference/errors#rate_limit_exceeded
                required:
                  - code
                  - message
            required:
              - error
    '500':
      description: The server has encountered a situation it does not know how to handle.
      content:
        application/json:
          schema:
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - internal_server_error
                    description: A short code indicating the error code returned.
                    example: internal_server_error
                  message:
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: >-
                      https://docs.eigenexplorer.com/api-reference/errors#internal_server_error
                required:
                  - code
                  - message
            required:
              - error

````